* macros_examples_listing_in_a_loop.sps.
SET MPRINT ON PRINTBACK ON.
* Create a dummy file for illustration purposes.
NEW FILE.
INPUT PROGRAM.
SET SEED=11171942.
NUMERIC v191 TO v247.
VECTOR v=v191 TO v247.
* create 20 cases.
LOOP v1=1 TO 20   /* v1 is the case id */.
- LOOP #cnt=1 TO 57.
-   DO IF MOD(#cnt,3)=0.
-    COMPUTE v(#cnt)=UNIFORM(1).
-   ELSE.
-    COMPUTE v(#cnt)=UNIFORM(1)>.5.
-   END IF.
- END LOOP.
- END CASE.
END LOOP.
END FILE.
END INPUT PROGRAM.
EXECUTE.

* define a macro to do the job.
DEFINE !listvar()

!DO !cnt=191 !TO 247 !BY 3
- FILTER OFF.
- COMPUTE flag=0.
  !LET !a1=!CONCAT('v',!cnt)
  !LET !a2=!CONCAT('v',!LENGTH(!CONCAT(!BLANKS(!cnt)," ")))
  !LET !a3=!CONCAT('v',!LENGTH(!CONCAT(!BLANKS(!cnt),"  ")))
- IF ( !a1=1 & !a2=0 ) flag=1.
- FILTER BY flag.
- LIST v1 !a1 !a2 !a3.
!DOEND

!ENDDEFINE.

*Call macro.
!listvar.

show.
