* macros_generate_data01.sps.
SET MPRINT OFF.
* simulate ratings assigned by each member of workgroup 
  to other members of the group.

DEFINE !simul (nbgrps=!TOKENS(1) 
              /nbpers=!TOKENS(1) 
              /mxscore=!TOKENS(1))
INPUT PROGRAM.
LOOP group=1 TO !nbgrps.
+LOOP rater=1 TO !nbpers.
+ LOOP ratee=1 TO !nbpers.
+ LEAVE group rater ratee.
* Change next command to fit requirements.
+ COMPUTE score1=RND(UNIFORM(!mxscore)+.5).
+ DO IF rater<>ratee /* exclude self rating */.
+  END CASE.
+ END IF.
+ END LOOP.
+END LOOP.
END LOOP.
END FILE.
END INPUT PROGRAM.
FORMATS ALL(F4).
!ENDDEFINE.

SET MPRINT=ON PRINTBACK ON.
* Simulate 10 groups of 6 persons where scores are 
   between 1 and 7.
!simul nbgrps=10 nbpers=6 mxscore=7.
FREQ VAR=score1.

