*macros_new_variables_containing_bounds_oms.sps.

DEFINE !AddCInt (vname=!TOKENS(1) /conf=!TOKENS(1) /fname=!TOKENS(1))
GET FILE=!fname.
OMS SELECT TABLES
  /IF SUBTYPES=['Descriptives']
  /DESTINATION FORMAT=SAV OUTFILE='c:\temp\temp.sav'
  /COLUMNS SEQUENCE=[r2]. 
EXAMINE
  VARIABLES=!vname
  /COMPARE GROUP /PLOT=NONE
  /STATISTICS DESCRIPTIVES
  /CINTERVAL !conf
  /MISSING LISTWISE
  /NOTOTAL.
OMSEND. 
STRING Var2 (a10).
COMPUTE Var2="Statistic". 
MATCH FILES FILE=*
  /TABLE='c:\temp\temp.sav'
  /BY Var2
  /DROP Command_ to Mean, @5TrimmedMean to Kurtosis.
EXECUTE.
DELETE VARIABLES Var2.
!ENDDEFINE.

** Example (95% CI for a large sample).
!addCInt   vname=salary conf=95 
    fname='c:\examples\data\Employee data.sav'.

** Example (90% CI for a small sample).
GET FILE='c:\examples\data\Employee data.sav'.
N OF CASES 15.
SAVE OUTFILE='c:\temp\eee data.sav'.
!addCInt  vname=salbegin  conf=90 
    fname='c:\temp\eee data.sav'.
