
*//////////////////////.
DEFINE !VarType (!POS=!CMDEND)
SAVE OUTFILE='c:\temp\temp.sav'.
MATCH FILES FILE=* /KEEP=!1.
N OF CASES 1.

SET ERRORS=no.
DO REPEAT v=!1.
- COMPUTE v=1.
END REPEAT.
SET ERRORS=yes.
FLIP.

IF MISSING(var001) var001=0.
COMPUTE nobreak=1.
MATCH FILES FILE=* /BY=nobreak /LAST=last.

DO IF $CASENUM=1.
- WRITE OUTFILE="c:\temp\string vars.sps" /"DEFINE !str()".
- WRITE OUTFILE="c:\temp\num vars.sps" /"DEFINE !num()".
END IF.

DO IF var001 = 0.
- WRITE OUTFILE="c:\temp\string vars.sps" /" " case_lbl.
- ELSE.
- WRITE OUTFILE="c:\temp\num vars.sps" /" " case_lbl.
END IF.

DO IF last.
- WRITE OUTFILE="c:\temp\string vars.sps" /"!ENDDEFINE.".
- WRITE OUTFILE="c:\temp\num vars.sps" /"!ENDDEFINE.".
END IF.
EXECUTE.

INCLUDE FILE="c:\temp\string vars.sps".
INCLUDE FILE="c:\temp\num vars.sps".
GET FILE='c:\temp\temp.sav'.
!ENDDEFINE.
*//////////////////////.


DEFINE !vtype (!POS=!TOKENS(1) 
	/ifnum=!DEFAULT("* Nothing to do") !TOKENS(1) 
	/ifstr=!DEFAULT("* Nothing to do") !TOKENS(1) 
	/ifmis=!DEFAULT("* Nothing to do") !TOKENS(1))
/* execute syntax depending on 'nature' of variable */
/* where 'nature' is numeric, string or missing (variable does not exist) */

!LET !nb=!BLANKS(1)
!DO !v !IN (!EVAL(!num)) 
  !IF (!UPCASE(!v) !EQ !UPCASE(!1)) !THEN 
     !LET !nb=!BLANKS(2)
     !BREAK 
  !IFEND 
!DOEND

!DO !v !IN (!EVAL(!str)) 
  !IF (!UPCASE(!v) !EQ !UPCASE(!1)) !THEN 
     !LET !nb=!BLANKS(3)
     !BREAK 
  !IFEND 
!DOEND


!IF (!nb !EQ !BLANKS(2)) !THEN 
!UNQUOTE(!ifnum) 
!ELSE !IF (!nb !EQ !BLANKS(3)) !THEN 
!UNQUOTE(!ifstr)
!ELSE
!UNQUOTE(!ifmis)
!IFEND
!IFEND.

!ENDDEFINE.


* Test 1: Variable is numeric.
GET FILE='c:\program files\spss\employee data.sav' .
SET MPRINT=no.
!VarType ALL .
SET MPRINT=yes.
!vtype salary 
	ifnum="COMPUTE salary2=salary" 
	ifstr="COMPUTE salary2=NUMBER(salary,F8)".
COMPUTE test=salary2*2.
LIST salary test /CASES=FROM 1 TO 5.
EXECUTE.


* Test 2: Variable is string.
GET FILE='c:\program files\spss\employee data.sav' /DROP=salary.
STRING salary(A10).
COMPUTE salary="45000".
SET MPRINT=no.
!VarType ALL .
SET MPRINT=yes.
!vtype salary 
	ifnum="COMPUTE salary2=salary" 
	ifstr="COMPUTE salary2=NUMBER(salary,F8)".
COMPUTE test=salary2*2.
LIST salary test /CASES=FROM 1 TO 5.
EXECUTE.

* Of course, the command in ifnum could be any spss command, including something like
* ifnum="INCLUDE 'c:\temp\syntax when num.sps'".


* Test3: Variable is missing from the file.
GET FILE='c:\program files\spss\employee data.sav' /DROP=salary.
SET MPRINT=no.
!VarType ALL .
SET MPRINT=yes.
!vtype sal2001 
	ifnum="COMPUTE sal2001=RND(sal2001)"
	ifmis="INCLUDE 'c:\temp\syntax when var does not exist.sps'".


* Test4: Var is numeric (so nothing to do).
GET FILE='c:\program files\spss\employee data.sav'.
SET MPRINT=no.
!VarType ALL .
SET MPRINT=yes.
!vtype salary 
	ifmis="INCLUDE 'c:\temp\syntax when var does not exist.sps'".

